#!/usr/bin/perl
# new_user.cgi
# Create a new webmin user

require './cds-lib.pl';
&ReadParse();


	if ($in{'msg_ok.x'} || $in{'cancel.x'}) {
		&redirect("");
		goto endoffile;	
	}
	
	if ($in{'confirm'}) {

		&header();

		@ulist = &list_cds();
	
		foreach $u (@ulist) {
			if ($u->{'name'} eq $in{'name'}) {
				&messagebox("CD already exists",1);
				goto endoffile;
			};
		}

		#Get the size of the CD
		#----------------------

		#make sure that the cdrom is not mounted
		`umount /dev/cdrom`;
		
		#Try and mount the cdrom
		if (!system("mount /dev/cdrom")) {
			
			#If it mounted successfully then run df to find the disk size
			open(DFPROCESS, "/bin/df /mnt/cdrom|");
				while (<DFPROCESS>) {
					s/\r|\n//g;

					#Replace multiple spaces with a :
					s/\s+/:/g;

					#Split the line by :
					@temparray = split(/:/,$_);

					#If the 2nd element doesn't contain "1k-blocks" then that is the size,
					#	divide it by 1000 to get MB and forget the decimal places
					if ($temparray[1] ne "1k-blocks") {$temparray[1] = $temparray[1] / 1000; $size = int $temparray[1];}
				}
			#Close the process
			close(DFPROCESS);

		}

		else {
			#If the CD cant be mounted then tell the user
			#	that there is no cd present.
			&messagebox("CD Not Present", 1);

			#Skip to the end
			goto endoffile;
		}

		#Show a progress window & post the size of the current cd to it
		print "<script language=VBSCRIPT>\nset copyingcd = Window.Open(\"progress.cgi?size=$size\", \"Progress\", \"toolbar=no, menubar=no, location=no, directories=no, status=no, resizeable=no, scrollbars=no, width=316, height=100\")\n</SCRIPT>";

		if(&create_cd($in{'name'})) {
			&messagebox("CD Copied Successfully", 1);	
		}	
		else {
			&messagebox("Error copying CD", 1);
		}
		
		print "<script language=VBSCRIPT>\ncopyingcd.close()\n</SCRIPT>";

		goto endoffile;
	}

	&header();

	&get_cdsize();
	print "<form method=post>\n";
	print "<table align=center width=350 border=0 background=\"images/newcd.gif\" height=122>\n";
	print "<tr>\n";
	print "<td valign=top>\n";
	print "<table width=100% border=0 height=100%>\n";
	print "<tr>\n";
	print "<td width=39%></td>\n";
	print "<td height=74 valign=bottom width=61%>\n";
	print "<input type=text name=name value=\"";

	system("dd if=/dev/cdrom bs=1 skip=32808 count=32 > /isos/temp.dat");
		open (CDTITLE, "/isos/temp.dat");
			while(<CDTITLE>) {
				s/\r|\n//g;
				print $_;
			}
		close (CDTITLE);
	system("rm /isos/temp.dat -f");

	print "\" style=\"background-color:#9999CC;border=0;color=#ffffff;font-family:Verdana;width:140\" maxlength=15>\n";
	print "</td>\n";
	print "</tr>\n";
	print "<tr>\n";
	print "<td height=* valign=center align=center colspan=2>\n";
	print "<input type=image name=submit src=images/newcd_btn.gif>\n";
	print "<input type=image name=cancel src=images/cancel_btn.gif>\n";
	print "<input type=hidden name=confirm value=1>\n";
	print "</td>\n";
	print "</tr>\n";
	print "</table>\n";
	print "</td>\n";
	print "</tr>\n";
	print "</table>\n";
	print "</form>\n";

endoffile:

&footer();