#!/usr/bin/perl
# new_user.cgi
# Create a new webmin user

require './acl-lib.pl';
&ReadParse();

if ($base_remote_user eq "root") {

	if ($in{'msg_ok.x'} || $in{'cancel.x'}) {
		&redirect("");
		goto endoffile;	
	}
	
	if ($in{'confirm'}) {

		&header(1);

		@ulist = &list_users();
	
		foreach $u (@ulist) {
			if ($u->{'name'} eq $in{'name'}) {
				&messagebox("User already exists",1);
				goto endoffile;
			};
		}

		$in{'pass'} =~ /:/ && &error($text{'save_ecolon'});
		$salt = chr(int(rand(26))+65).chr(int(rand(26))+65);
		$user{'pass'} = crypt($in{'pass'}, $salt);
		$user{'sync'} = 0;
		$user{'lang'} = "en";
		$user{'notabs'} = 0;
		$user{'name'} = $in{'name'};

		&create_user(\%user);
	
		&restart_miniserv();
		&webmin_log("create", "user", $user{'name'}, \%in);
		&messagebox("User Added", 1);
		goto endoffile;
	}

	&header(1);

	print "<form method=post>\n";
	print "<table align=center width=350 border=0 background=\"images/newuser.gif\" height=160>\n";
	print "<tr>\n";
	print "<td valign=top>\n";
	print "<table width=100% border=0 height=100%>\n";
	print "<tr>\n";
	print "<td width=39%></td>\n";
	print "<td height=74 valign=bottom width=61%>\n";
	print "<input type=text name=name value=\"\" style=\"background-color:#9999CC;border=0;color=#ffffff;font-family:Verdana;width:140\" maxlength=15>\n";
	print "</td>\n";
	print "</tr>\n";
	print "<tr>\n";
	print "<td width=39%></td>\n";
	print "<td height=29 valign=bottom width=61%>\n";
	print "<input type=password name=pass value=\"\" style=\"background-color:#9999CC;border=0;color=#ffffff;font-family:Verdana;width:140\" maxlength=15>\n";
	print "</td>\n";
	print "</tr>\n";
	print "<tr>\n";
	print "<td height=* valign=center align=center colspan=2>\n";
	print "<input type=image name=submit src=images/newuser_btn.gif>\n";
	print "<input type=image name=cancel src=images/cancel_btn.gif>\n";
	print "<input type=hidden name=confirm value=1>\n";
	print "</td>\n";
	print "</tr>\n";
	print "</table>\n";
	print "</td>\n";
	print "</tr>\n";
	print "</table>\n";
	print "</form>\n";
}
else {
	&messagebox("Access Denied");
}

endoffile:

&footer();